<?php
/**
* @version      2.4.2 23.10.2010
* @author       MAXXmarketing GmbH
* @package      Jshopping
* @copyright    Copyright (C) 2010 webdesigner-profi.de. All rights reserved.
* @license      GNU/GPL
*/

class jshopProduct extends JTableAvto {    

    function __construct( &$_db ){
        parent::__construct( '#__jshopping_products', 'product_id', $_db );
    }
    
    function setAttributeActive($attribs){
        $this->attribute_active = $attribs;
        if (is_array($this->attribute_active) && count($this->attribute_active)){
            $where = "";
            foreach($this->attribute_active as $k=>$v){
                $where.=" and PA.attr_".$k." = '".$this->_db->getEscaped($v)."' ";
            }          
            $query = "select PA.* from `#__jshopping_products_attr` as PA where PA.product_id = '".$this->_db->getEscaped($this->product_id)."' ".$where; 
            $this->_db->setQuery($query);
            $this->attribute_active_data = $this->_db->loadObject();    
        }else{
            $this->attribute_active_data = NULL;
        }
    }
    
    function getRequireAttribute(){
        $attribs = &JSFactory::getAllAttributes();
        $prodAttribVal = $this->getAttributes();
        $require = array();
        if (count($prodAttribVal)){             
            $prodAtrtib = $prodAttribVal[0];
            foreach($attribs as $attrib){
                $field = "attr_".$attrib->attr_id;
                if ($prodAtrtib->$field) $require[] = $attrib->attr_id;
            }
        }
        return $require;
    }
    
    function getAttributes() {
        $query = "SELECT * FROM `#__jshopping_products_attr` WHERE product_id = '".$this->product_id."' ORDER BY product_attr_id";
        $this->_db->setQuery($query);
        return $this->_db->loadObjectList();
    }    
    
    function getAttribValue($attr_id, $other_attr = array(), $onlyExistProduct = 0){
        $lang = &JSFactory::getLang();
        $where = "";
        foreach($other_attr as $k=>$v){
            $where.=" and PA.attr_$k='$v'";
        }
        if ($onlyExistProduct) $where.=" and PA.count>0 ";
        
        $field = "attr_".$attr_id;
        $query = "SELECT distinct PA.$field as val_id, V.`".$lang->get("name")."` as value_name, V.image
                  FROM `#__jshopping_products_attr` as PA INNER JOIN #__jshopping_attr_values as V ON PA.$field=V.value_id
                  WHERE PA.product_id = '".$this->product_id."' ".$where."
                  ORDER BY V.value_ordering";
        $this->_db->setQuery($query);
        return $this->_db->loadObjectList();
    }
    
    function getAttributesDatas($selected = array()){
        $jshopConfig = &JSFactory::getConfig();
        $data = array();
        $requireAttribute = $this->getRequireAttribute();
        $actived = array();
        foreach($requireAttribute as $attr_id){
            $options = $this->getAttribValue($attr_id, $actived, $jshopConfig->hide_product_not_avaible_stock);
            $data['attributeValues'][$attr_id] = $options;
            if (!$jshopConfig->product_attribut_first_value_empty){
                $actived[$attr_id] = $options[0]->val_id;
            }
            if ($selected[$attr_id]){
                $testActived = 0;
                foreach($options as $tmp) if ($tmp->val_id==$selected[$attr_id]) $testActived = 1;
                if ($testActived){
                    $actived[$attr_id] = $selected[$attr_id];
                }
            }
        }
        
        if (count($requireAttribute) == count($actived)){
            $data['attributeActive'] = $actived;
        }else{
            $data['attributeActive'] = array();
        }
        
        $data['attributeSelected'] = $actived;
        return $data;
    }

    function getCategories() {
        $db =& JFactory::getDBO(); 
        $query = "SELECT * FROM `#__jshopping_products_to_categories` WHERE product_id = '".$this->_db->getEscaped($this->product_id)."'";
        $this->_db->setQuery($query);
        return $this->_db->loadObjectList();
    }

    function getName() {
        $lang = &JSFactory::getLang();
        $name = $lang->get('name');
        return $this->$name;
    }

    function updateProductInStock($listProducts) {
        $db =& JFactory::getDBO(); 

        foreach ($listProducts as $prod) {
            if ( is_array($prod['attr']) && count($prod['attr']) ){                
                $where="";
                foreach($prod['attr'] as $k=>$v){
                    $where.=" and `attr_$k`='".intval($v)."'";        
                }
                $query = "update `#__jshopping_products_attr` set `count`=`count`-".intval($prod['quantity'])." where product_id='".intval($prod['product_id'])."' ".$where;
                $db->setQuery($query);
                $db->query();
                
                $query="select sum(count) as qty from `#__jshopping_products_attr` where product_id='".intval($prod['product_id'])."' and `count`>0 ";
                $db->setQuery($query);
                $qty = $db->loadResult();
                
                $query = "UPDATE `#__jshopping_products` SET product_quantity = '".intval($qty)."' WHERE product_id = '".intval($prod['product_id'])."'";
                $db->setQuery($query);
                $db->query();
                
            }else{
                $query = "UPDATE `#__jshopping_products` SET product_quantity = product_quantity - ".intval($prod['quantity'])." WHERE product_id = '".intval($prod['product_id'])."'";
                $db->setQuery($query);
                $db->query();
            }
        }
        
    }

    function getPriceWithParams(){
        if (isset($this->attribute_active_data->price)){
            return $this->attribute_active_data->price;
        }else{
            return $this->product_price;
        }
    }
    
    function getEan(){   
        if (isset($this->attribute_active_data->ean)){     
            return $this->attribute_active_data->ean;
        }else{
            return $this->product_ean;
        }
    }
    
    function getQty(){
        if (isset($this->attribute_active_data->count)){
            return $this->attribute_active_data->count;
        }else{
            return $this->product_quantity;
        }
    }
    
    function getQtyInStock(){
        $qtyInStock = $this->getQty();        
        if ($qtyInStock < 0) $qtyInStock = 0;
    return $qtyInStock;
    }

    function getImages() {        
        $query = "SELECT I.*, IF(P.product_name_image=I.image_name,0,1) as sort FROM `#__jshopping_products_images` as I left join `#__jshopping_products` as P on P.product_id=I.product_id
                 WHERE I.product_id = '" . $this->_db->getEscaped($this->product_id) . "' ORDER BY sort,I.image_id";
        $this->_db->setQuery($query);
        return $this->_db->loadObjectList();
    }

    function getVideos() {        
        $query = "SELECT  video_name, video_id, video_preview FROM `#__jshopping_products_videos` WHERE product_id = '".$this->_db->getEscaped($this->product_id)."'";
        $this->_db->setQuery($query);
        return $this->_db->loadObjectList();
    }
    
    function getFiles() {        
        $query = "SELECT * FROM `#__jshopping_products_files` WHERE product_id = '".$this->_db->getEscaped($this->product_id)."' order by `ordering` ";
        $this->_db->setQuery($query);
        return $this->_db->loadObjectList();
    }
    
    function getDemoFiles() {        
        $query = "SELECT * FROM `#__jshopping_products_files` WHERE product_id = '".$this->_db->getEscaped($this->product_id)."' and demo!='' order by `ordering` ";
        $this->_db->setQuery($query);
        return $this->_db->loadObjectList();
    }
    
    function getSaleFiles() {        
        $query = "SELECT id, file, file_descr FROM `#__jshopping_products_files` WHERE product_id = '".$this->_db->getEscaped($this->product_id)."' and file!='' order by `ordering` ";
        $this->_db->setQuery($query);
        return $this->_db->loadObjectList();
    }
    
    function getManufacturerInfo(){
        $lang = &JSFactory::getLang();
        $query = "SELECT manufacturer_url, manufacturer_logo, `".$lang->get('name')."` as name FROM `#__jshopping_manufacturers` WHERE manufacturer_id = '".$this->_db->getEscaped($this->product_manufacturer_id)."'";
        $this->_db->setQuery($query);
        return $this->_db->loadObject();
    }

    function getRelatedProducts() {
        $jshopConfig = &JSFactory::getConfig();
        $lang = &JSFactory::getLang();
        
        $advquery = "";
        if ($jshopConfig->hide_product_not_avaible_stock){
            $advquery .= " AND prod.product_quantity > 0";
        }
        
        $query = "SELECT relation.product_related_id AS product_id, (prod.product_price*" . $jshopConfig->currency_value . ") AS product_price, pr_cat.category_id, prod.product_thumb_image, prod.product_is_add_price, prod.`".$lang->get('name')."` as name
                FROM `#__jshopping_products_relations` AS relation
                INNER JOIN `#__jshopping_products` AS prod ON relation.product_related_id = prod.product_id
                LEFT JOIN `#__jshopping_products_to_categories` AS pr_cat ON pr_cat.product_id = relation.product_related_id
                WHERE relation.product_id = '" . $this->_db->getEscaped($this->product_id) . "' AND prod.product_publish = '1' ".$advquery." group by prod.product_id ";
        $this->_db->setQuery($query);        
        $this->product_related = $this->_db->loadObjectList();
        
        $userShop = &JSFactory::getUserShop();
        foreach ($this->product_related as $key => $value) {
            $this->product_related[$key]->product_link = SEFLink('index.php?option=com_jshopping&controller=product&task=view&category_id='.$value->category_id.'&product_id='.$value->product_id);
            $this->product_related[$key]->product_price = getPriceDiscount($this->product_related[$key]->product_price, $userShop->percent_discount);            
        }
                        
        return $this->product_related;
    }

    /**
    * get first catagory for product
    */    
    function getCategory() {
        $query = "SELECT cat.category_id FROM `#__jshopping_products_to_categories` AS cat
                WHERE cat.product_id = '" . $this->_db->getEscaped($this->product_id) . "'
                LIMIT 0,1";
        $this->_db->setQuery($query);
        $this->category_id = $this->_db->loadResult();
    }
    
    function getExtendsData() {
        $this->getRelatedProducts();
        $this->getDescription();
        $this->getPricePreview();
        $this->getTax();
        $this->getDeliveryTime();
    }
    
    function getDeliveryTime(){
        $jshopConfig = &JSFactory::getConfig();
                
        if ($jshopConfig->show_delivery_time && $this->delivery_times_id){
            $deliveryTimes = &JTable::getInstance('deliveryTimes', 'jshop');
            $deliveryTimes->load($this->delivery_times_id);
            $this->delivery_time = $deliveryTimes->getName();
        }else{
            $this->delivery_time = "";    
        }
    }

    function getDescription() {
        $lang = &JSFactory::getLang();
        $name = $lang->get('name');
        $short_description = $lang->get('short_description');
        $description = $lang->get('description');
        $meta_title = $lang->get('meta_title');
        $meta_keyword = $lang->get('meta_keyword');
        $meta_description = $lang->get('meta_description');
        
        $this->name = $this->$name;
        $this->short_description = $this->$short_description;
        $this->description = $this->$description;
        $this->meta_title = $this->$meta_title;
        $this->meta_keyword = $this->$meta_keyword;
        $this->meta_description = $this->$meta_description;
    }
    
    function getPricePreview(){                
        $this->getPrice(1, 0, 0);
        if ($this->product_is_add_price){
            $this->product_add_prices = array_reverse($this->product_add_prices);
        }
        $this->reloadPriceForCurrency();
        $this->reloadPriceForUserDiscount();        
    }
    
    function getPrice($quantity = 1, $enableCurrency = 1, $enableUserDiscount = 0) {
        $jshopConfig = &JSFactory::getConfig();
                
        $this->product_price_calculate = $this->getPriceWithParams();                
        
        if ($this->product_is_add_price){
            $this->getAddPrices();        
        }
        
        if ($quantity && $this->product_is_add_price){
            foreach ($this->product_add_prices as $key=>$value){
                if ($quantity >= $value->product_quantity_start){
                    $this->product_price_calculate = $value->price;
                    break;    
                } 
            }
        }
        
        if ($enableCurrency){
            $this->product_price_calculate = $this->product_price_calculate * $jshopConfig->currency_value;
        }
        
        if ($enableUserDiscount){
            $userShop = &JSFactory::getUserShop();
            $this->product_price_calculate = getPriceDiscount($this->product_price_calculate, $userShop->percent_discount);    
        }
        return $this->product_price_calculate;
    }
    
    function getPriceCalculate(){
        return $this->product_price_calculate;
    }
    
    function getAddPrices(){
        $jshopConfig = &JSFactory::getConfig();
        $productprice = &JTable::getInstance('productprice', 'jshop');                
        $this->product_add_prices = $productprice->getAddPrices($this->product_id);
        
        foreach($this->product_add_prices as $k=>$v){
            if ($jshopConfig->product_price_qty_discount == 1){
                $this->product_add_prices[$k]->price = $this->product_price_calculate - $v->discount; //discount value
            }else{
                $this->product_add_prices[$k]->price = $this->product_price_calculate - ($this->product_price_calculate * $v->discount / 100); //discount percent
            }
        }                                      
    }
    
    function getTax() {        
        $query = "SELECT tax_value FROM `#__jshopping_taxes` WHERE tax_id = '" . $this->_db->getEscaped($this->product_tax_id) . "'";
        $this->_db->setQuery($query);
        $this->product_tax = $this->_db->loadResult();
    }
    
    function reloadPriceForCurrency(){
        $jshopConfig = &JSFactory::getConfig();        
        $this->product_price_calculate = $this->product_price_calculate * $jshopConfig->currency_value;
        $this->product_old_price = $this->product_old_price * $jshopConfig->currency_value;
        if (is_array($this->product_add_prices)){
            foreach ($this->product_add_prices as $key=>$value){            
                $this->product_add_prices[$key]->price = $this->product_add_prices[$key]->price * $jshopConfig->currency_value;
            }
        }        
    }
    
    function reloadPriceForUserDiscount(){
        $userShop = &JSFactory::getUserShop();
        $this->product_price_calculate = getPriceDiscount($this->product_price_calculate, $userShop->percent_discount);
        $this->product_old_price = getPriceDiscount($this->product_old_price, $userShop->percent_discount);
        if (is_array($this->product_add_prices)){
            foreach ($this->product_add_prices as $key=>$value){
                $this->product_add_prices[$key]->price = getPriceDiscount($this->product_add_prices[$key]->price, $userShop->percent_discount);
            }
        }        
    }
    
    function reloadPricesForAddPrice(){
        if (is_array($this->product_add_prices)){
            $jshopConfig = &JSFactory::getConfig();
            $userShop = &JSFactory::getUserShop();            
            foreach ($this->product_add_prices as $key=>$value){            
                $this->product_add_prices[$key]->price = $this->product_add_prices[$key]->price * $jshopConfig->currency_value;
                $this->product_add_prices[$key]->price = getPriceDiscount($this->product_add_prices[$key]->price, $userShop->percent_discount);
            }
        }
    }    
    
    
    function getLastProducts($count, $array_categories = null, $rand = 0) {
        $jshopConfig = &JSFactory::getConfig();             

        $db =& JFactory::getDBO();
        $lang = &JSFactory::getLang();
        $where_add = '';
        if(count($array_categories)) {
            $where_add = " AND (";
            foreach ($array_categories as $key => $value) {
                $where_add .= " pr_cat.category_id = '" . $value . "' OR ";
            }
            $where_add = substr($where_add,0,strlen($where_add) - 4);
            $where_add .= ")";
        }
                
        if ($jshopConfig->hide_product_not_avaible_stock){
            $where_add .= " AND prod.product_quantity > 0";
        }
 
        $order_add = ($rand)?("RAND()"):("prod.product_date_added DESC");
        $query = "SELECT prod.`".$lang->get('name')."` as name, prod.`".$lang->get('short_description')."` as short_description, prod.product_id, prod.product_ean, prod.product_url, prod.product_thumb_image, prod.product_full_image, pr_cat.category_id, (prod.product_price*".$jshopConfig->currency_value.") AS product_price, product_is_add_price
                  FROM `#__jshopping_products` AS prod
                  INNER JOIN `#__jshopping_products_to_categories` AS pr_cat ON pr_cat.product_id = prod.product_id
                  WHERE prod.product_publish = '1'" . $where_add . "
                  GROUP BY prod.product_id ORDER BY " . $order_add . " LIMIT " . $count;
        $db->setQuery($query);
        $products = $db->loadObjectList();
        $userShop = &JSFactory::getUserShop();
        foreach ($products as $key=>$value){
            $products[$key]->product_price = getPriceDiscount($products[$key]->product_price, $userShop->percent_discount);    
        }
        return $products;
    }
    
    //not test
    function getBestProducts($product_ids){
        $jshopConfig = &JSFactory::getConfig();
        $db =& JFactory::getDBO(); 
        if (strlen($product_ids)){
            $where_add = " AND prod.product_id IN (" . $product_ids . ")";
            if ($jshopConfig->hide_product_not_avaible_stock){
                $where_add .= " AND prod.product_quantity > 0";
            }
            $query = "SELECT prod.`".$lang->get('name')."` as name, prod.`".$lang->get('short_description')."` as short_description, prod.product_id, prod.product_ean, prod.product_url, prod.product_thumb_image, pr_cat.category_id, (prod.product_price*" . $jshopConfig->currency_value . ") AS product_price
                      FROM `#__jshopping_products` AS prod
                      INNER JOIN `#__jshopping_products_to_categories` AS pr_cat ON pr_cat.product_id = prod.product_id
                      WHERE prod.product_publish = '1'" . $where_add . "
                      GROUP BY prod.product_id
                      ORDER BY prod.product_id";
            $db->setQuery($query);
            return $db->loadObjectList();
        }
    }
    
    
    function getBestSellers($count, $array_categories = null){
        $jshopConfig = &JSFactory::getConfig();             

        $db =& JFactory::getDBO();
        $lang = &JSFactory::getLang();

        $where_add = '';
        if(count($array_categories)) {
            $where_add = " AND (";
            foreach ($array_categories as $key => $value) {
                $where_add .= " pr_cat.category_id = '" . $value . "' OR ";
            }
            $where_add = substr($where_add, 0, strlen($where_add) - 4);
            $where_add .= ")";
        }
        
        if ($jshopConfig->hide_product_not_avaible_stock){
            $where_add .= " AND prod.product_quantity > 0";
        }
 
        $query = "SELECT  SUM(OI.product_quantity) as max_num, prod.`".$lang->get('name')."` as name, prod.`".$lang->get('short_description')."` as short_description, prod.product_id, prod.product_ean, prod.product_url, prod.product_thumb_image, prod.product_full_image, pr_cat.category_id,  (prod.product_price*".$jshopConfig->currency_value.") AS product_price, product_is_add_price
                  FROM #__jshopping_order_item AS OI 
                  INNER JOIN `#__jshopping_products` AS prod   ON prod.product_id=OI.product_id
                  INNER JOIN `#__jshopping_products_to_categories` AS pr_cat ON pr_cat.product_id = prod.product_id
                  WHERE prod.product_publish = '1'" . $where_add . "
                  GROUP BY prod.product_id
                  ORDER BY max_num desc LIMIT " . $count;
        $db->setQuery($query);
        $products = $db->loadObjectList();
        $userShop = &JSFactory::getUserShop();
        foreach ($products as $key=>$value){
            $products[$key]->product_price = getPriceDiscount($products[$key]->product_price, $userShop->percent_discount);    
        }
        return $products;
    }
    
    function getReviews($limitstart = 0, $limit = 20) {
        $query = "SELECT * FROM `#__jshopping_products_reviews` WHERE product_id = '" . $this->_db->getEscaped($this->product_id) . "' order by review_id desc";
        $this->_db->setQuery($query, $limitstart, $limit);
        return $this->_db->loadObjectList();
    }
    
    function getReviewsCount(){
        $query = "SELECT count(review_id) FROM `#__jshopping_products_reviews` WHERE product_id = '" . $this->_db->getEscaped($this->product_id) . "'";
        $this->_db->setQuery($query);
        return $this->_db->loadResult();
    }

    function getAverageRating() {
        $query = "SELECT ROUND(AVG(mark),2) FROM `#__jshopping_products_reviews` WHERE product_id = '".$this->_db->getEscaped($this->product_id)."' and mark > 0";
        $this->_db->setQuery($query);
        return $this->_db->loadResult();
    }
    
    function loadAverageRating(){
        $this->average_rating = $this->getAverageRating();        
    }
    
    function loadReviewsCount(){
        $this->reviews_count = $this->getReviewsCount();
    }

}
?>